//
//  HsOTCServicePRPage.m
//  TZYJ_IPhone
//
//  Created by Kun on 14-8-20.
//
//

#import "HsOTCServicePRPage.h"
#import "HsOtcDefine.h"
#import "HsTextField.h"
#import "HsOpenFundCellData.h"
#import "HsFinanceServiceCodeQuery.h"
#import "HsTradeQueryUtils.h"
#import "HsServicePREntrust.h"
#import "HsSuperMarketUtils.h"
#import "HsTradeSuitableTestPage.h"
#import "HsFundSignContractView.h"
#import "HsSignContractView.h"
#import "HsCustomerAddAuthority.h"
#import "HsOTCEtcContractSign.h"
#import "HsOTCEtcContractQuery.h"

#define TRADE_ENABLE_MONEY 405
#define SERVICE_PRODUCT_QUERY_SENDERID 10000
#define SERVICE_PRODUCT_ENTRUST_SENDERID 10010

#define SIGNATURE_AGREEMENT_FUNCTIONID 1000
#define ECONTRACT_QUERY_SENDERID 		28385

#define ALWAYS_SIGN_CONTRACT @"2"
#define ONE_SIGN_CONTRACT @"1"
#define SIGNED_CONTRACT  @"0"

#define ALERT_ENTRUST_COMFIRM   100

#define SIGNATURE_AGREEMENT_TAG  300
#define SENDID_SIGN_ECONTRACT    38384

@interface HsOTCServicePRPage()<HsFundSignContractProtocol>
{
    UIScrollView        *_scrollView;
    NSString            *_targetName;
    UILabel             *_productCodeHint;//产品代码
    UITextField         *_productCodeField;
    UILabel             *_productNameHint;//产品名称
    UILabel             *_productNameValue;
    UILabel             *_productTermHint;//产品期限
    UILabel             *_productTermValue;
    UILabel             *_issuePriceHint;
    UILabel             *_issuePriceValue;
    UILabel             *_enableMoneyHint;//可用资金
    UILabel             *_enableMoneyValue;
    UILabel             *_entrustAmountHint;//认购金额\申购金额\赎回份额
    UITextField         *_entrustAmountField;
    UILabel				*_hintLabel;
    UIButton            *_entrustBtn;//委托按钮
    UIButton            *_resetButton;
    HsPageType           _pageType;
}

@property (nonatomic, retain) NSDictionary *productTermDic;
@property (nonatomic, retain) NSString *prodTaNo;
@property (nonatomic, retain) NSString *eContractFlag; 		//电子合同签署标示
@property (nonatomic, retain) NSString *eContractContent;	//电子合同url链接
@property (nonatomic, assign) BOOL	   isHasEContract;

@end


@implementation HsOTCServicePRPage


- (void)dealloc
{
    [_scrollView release];
    
    self.productTermDic = nil;
    self.prodTaNo = nil;
    self.eContractFlag = nil;
    self.eContractContent = nil;
    [super dealloc];

}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
        _scrollView = [[UIScrollView alloc]  initWithFrame: CGRectMake(0, 0, MAIN_SCREEN_WIDTH, MAIN_SCREEN_HEIGHT - MAIN_NAVI_HEIGHT)] ;
      
        
        [self addSubview: _scrollView];
           _productCodeHint       = [self _generateHintLabel];
        _productCodeHint.text  = @"产品代码";
        _productCodeField      = [self _generateTextField];
        [_productCodeField addTarget: self action: @selector(_textFieldEditingChanged:) forControlEvents: UIControlEventEditingChanged];
        
        _productNameHint       = [self _generateHintLabel];
        _productNameHint.text  = @"产品名称";
        _productNameValue      = [self _generateHintLabel];
        
        _productTermHint        = [self _generateHintLabel];
        _productTermHint.text   = @"产品期限";
        _productTermValue 	= [self _generateHintLabel];
        
   		_issuePriceHint			= [self _generateHintLabel];
        _issuePriceHint.text   =@"产品单价";
        _issuePriceValue = [self _generateHintLabel];
   
        _enableMoneyHint		= [self _generateHintLabel];
        _enableMoneyHint.text  = @"可用资金";
        _enableMoneyValue      = [self _generateHintLabel];
        
        _entrustAmountHint     = [self _generateHintLabel];
        _entrustAmountHint.text = @"购买价格";
        _entrustAmountField    = [self _generateTextField];
        
        _hintLabel				= [self _generateHintLabel];
        _hintLabel.font			= [UIFont systemFontOfSize:14.0];
        _hintLabel.numberOfLines = 0;
        
        //委托按钮
        _entrustBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [_entrustBtn setTitle: @"委托" forState: UIControlStateNormal];
        [_entrustBtn setTitleColor: [HsConfigration uiColorOfCSS:@"tradebtnfontcolor" forKey:@"fc"]  forState: UIControlStateNormal];
        [_entrustBtn setBackgroundImage: [IMAGEOFFILE: TRADE_IMAGE_CONFIRMBUY_N] forState: UIControlStateNormal];
        [_entrustBtn addTarget:self action: @selector(confirmPressed) forControlEvents:UIControlEventTouchUpInside];
        _entrustBtn.titleLabel.font = [HsConfigration systemFontOfSize:16.0f];
        [_scrollView addSubview:_entrustBtn];
        //重置按钮
//        _resetButton = [UIButton buttonWithType:UIButtonTypeCustom];
//        [_resetButton setTitle: @"重置" forState: UIControlStateNormal];
//        [_resetButton setTitleColor: [UIColor whiteColor]  forState: UIControlStateNormal];
//        [_resetButton setBackgroundImage: [IMAGEOFFILE: TRADE_IMAGE_CLEAR_N] forState: UIControlStateNormal];
//        [_resetButton addTarget:self action: @selector(resetPressed) forControlEvents:UIControlEventTouchUpInside];
//        _resetButton.titleLabel.font = [HsConfigration systemFontOfSize:16.0f];
//        [_scrollView addSubview:_resetButton];
        
        //从配置项中读取产品期限
        self.productTermDic = [HsSuperMarketUtils getProductTermDic];
        
    }
    return self;
}


-(void)setFrame:(CGRect)frame
{
    [super setFrame:frame];
//    if (self.pageType == HsPageOTCStockProductSubscribe || self.pageType == HsPageOTCProtocolProductSubscribe ||self.pageType == HsPageOTCBankProductSubscribe) {
//        _enableMoneyHint.text   = @"可用资金";
//        _entrustAmountHint.text = @"认购金额";
//    }
//    else if (self.pageType == HsPageOTCStockProductPurchase || self.pageType == HsPageOTCBankProductPurchase){
//        _enableMoneyHint.text   = @"可用资金";
//        _entrustAmountHint.text = @"申购金额";
//    }
//    else if (self.pageType == HsPageOTCStockProductRedeem || self.pageType == HsPageOTCBankProductRedeem){
//        _enableMoneyHint.text   = @"可赎份额";
//        _entrustAmountHint.text =  @"赎回份额";
//    }
    
    CGFloat leftWidth    = 85;
    CGFloat rightWidth   = 200;
    CGFloat height       = 30;
    CGFloat yPos         = 15;
    CGFloat xPos         = 10;
    _productCodeHint.frame    = CGRectMake(xPos, yPos, leftWidth, height);
    _productCodeField.frame   = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
    yPos                      += height + 10;
    _productNameHint.frame    = CGRectMake(xPos, yPos, leftWidth, height);
    _productNameValue.frame   = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
//    yPos                      += height + 10;
//    _productTermHint.frame    = CGRectMake(xPos, yPos, leftWidth, height);
//    _productTermValue.frame   = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
    yPos                      += height + 10;
    _issuePriceHint.frame     = CGRectMake(xPos, yPos, leftWidth, height);
    _issuePriceValue.frame    = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
    yPos                      += height + 10;
    _enableMoneyHint.frame    = CGRectMake(xPos, yPos, leftWidth, height);
    _enableMoneyValue.frame   = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
    yPos                      += height + 10;
    _entrustAmountHint.frame  = CGRectMake(xPos, yPos, leftWidth, height);
    _entrustAmountField.frame = CGRectMake(xPos + leftWidth, yPos, rightWidth, height);
    yPos                      += height + 10;
    _hintLabel.frame		  = CGRectMake(xPos, yPos, MAIN_SCREEN_WIDTH - 2*xPos, height+20);
    yPos                      += height + 10;
    _entrustBtn.frame         = CGRectMake(xPos, yPos + height,  MAIN_SCREEN_WIDTH - 2*xPos, height);
//    _resetButton.frame        = CGRectMake(xPos + 20 +(leftWidth + rightWidth - 10)/2, yPos + height, (leftWidth + rightWidth - 10)/2, height);
}

- (void)setData:(id)data
{
    if (data == nil)
    {
        return;
    }
    
    if (![data isKindOfClass:[HsOpenFundCellData class]])
    {
        return;
    }
    
    HsOpenFundCellData *fundData = data;
    _productCodeField.text = fundData.fundCode;
    _productNameValue.text = fundData.fundName;
 	[self _textFieldEditingChanged:_productCodeField];
}
- (void)componentDidDisplay
{
    [_scrollView setContentOffset: CGPointMake(0, 0) animated: NO];
    //查询可用金额
    [HsTradeQueryUtils sendBankCapitalQuery:self senderID:TRADE_ENABLE_MONEY];
    
}

#pragma mark - network request

- (void)sendProductCodeInfoRequest
{
    HsFinanceServiceCodeQuery *packet = [[HsFinanceServiceCodeQuery alloc] init];
    [packet setProdCode:_productCodeField.text];
    
    HsNetEvent *event = [[HsNetEvent alloc] initWithPacketObject:packet];
    [event setSenderId:SERVICE_PRODUCT_QUERY_SENDERID];
    [HsNetworkController sendRequest:event Delegate:self];
    [packet release];
    [event release];
    
}

- (void)responseForCodeInfoRequest:(HsNetEvent*)event
{
    HsFinanceServiceCodeQuery *packet = [[HsFinanceServiceCodeQuery alloc] initWithStream:[event getMessageBody]];
    if ([packet getRowCount] < 2) {
        [HsConfigration MessageBox:@"此产品代码没找到！"];
    }
    else{
        _productNameValue.text            = [packet getProdName];
        //_productTermValue.text            = [packet getProdTerm];
        _issuePriceValue.text             = [NSString stringWithFormat:@"%@元/月",[packet getIssuePrice]];
        self.prodTaNo = [packet getProdtaNo];
        
        self.eContractFlag  = [packet getStringValue:@"econtract_flag" ];
        self.eContractContent = [packet getStringValue:@"econtract_content"];
        NSString *s = [_productTermDic objectForKey:_productCodeField.text];
        _hintLabel.text = [NSString stringWithFormat:@"本产品至少需购买%@个月，请输入%@或%@以上整数倍产品价格的金额",s,s,s];
    }
    [packet release];
}




- (void)responseForBankCapital:(HsNetEvent*) event{
    HsBankCapitalQuery *bankCapital = [[HsBankCapitalQuery alloc]
                                       initWithStream: [event getMessageBody]] ;
    _enableMoneyValue.text = [bankCapital getEnableBalance];
    [bankCapital release];
    [self sendEContractQuery];
}
//电子合同流水查询
- (void)sendEContractQuery
{
    HsOTCEtcContractQuery *packet = [[HsOTCEtcContractQuery alloc] init];
    [packet setProdCode:_productCodeField.text];
    
    [[HsTradeConfigration sharedManager].usermodels setLoginInfoToPacket:packet];
    HsNetEvent *event = [[HsNetEvent alloc] initWithPacketObject:packet];
    
    [event setSenderId:ECONTRACT_QUERY_SENDERID];
    [HsNetworkController sendRequest:event Delegate:self];
    
    [packet release];
    [event release];
}

- (void)responseForEContractQuery:(HsNetEvent*)event
{
    HsOTCEtcContractQuery *packet = [[HsOTCEtcContractQuery alloc] initWithStream:[event getMessageBody]];
    if ([packet getRowCount] > 1) {
        //有数据 认为是签署过合同
        _isHasEContract = YES;
    }
    else
    {
        //未签署合同
        _isHasEContract = NO;
        
    }
    [packet release];
}



//购买
- (void)sendServicePREntrust
{
    HsServicePREntrust *packet = [[HsServicePREntrust alloc] init];
    [packet setPayKind:@"0"];
//    [packet setBeginDate:@"20140826"];
//    [packet setEndDate:@"20140926"];
//
    [packet setProdtaNo:self.prodTaNo];
    NSDate *today=[NSDate date];
    NSDateFormatter  *dateformatter=[[NSDateFormatter alloc] init];
    [dateformatter setDateFormat:@"YYYYMMdd"];
    
    
    NSDateComponents *dateComponents = [[NSDateComponents alloc] init];
     NSCalendar *calendar = [NSCalendar currentCalendar];
    [dateComponents setDay:1];
    
    NSDate *newDate = [calendar dateByAddingComponents:dateComponents toDate:today options:0];
   NSString *beiginDate=[dateformatter stringFromDate:newDate];
    
    [dateComponents setMonth: ([_entrustAmountField.text integerValue]/ [_issuePriceValue.text integerValue])];
    newDate = [calendar dateByAddingComponents:dateComponents toDate:newDate options:0];
    NSString *endDate = [dateformatter stringFromDate:newDate];
    [dateComponents release];
    [dateformatter release];
    
    [packet setBeginDate:beiginDate];
    [packet setEndDate:endDate];
    
    [packet setProdCode:_productCodeField.text];
    [packet setConsumeBalance:_entrustAmountField.text];
    [[HsTradeConfigration sharedManager].usermodels setLoginInfoToPacket:packet];
    HsNetEvent *event = [[HsNetEvent alloc] initWithPacketObject:packet];
    [event setSenderId:SERVICE_PRODUCT_ENTRUST_SENDERID];
    [HsNetworkController sendRequest:event Delegate:self];
    [packet release];
    [event release];
}

- (void)responseForServicePREntrust:(HsNetEvent*)event
{
    HsServicePREntrust *packet = [[HsServicePREntrust alloc] initWithStream:[event getMessageBody]];
    [HsConfigration MessageBox:[NSString stringWithFormat:@"委托成功,委托编号为:%@！",[packet getBatchNo]]];
     [packet release];
    [self resetPressed];
}
- (void)sendSignEContract
{
    HsOTCEtcContractSign *packet = [[HsOTCEtcContractSign alloc] init];
    [packet setProdCode:_productCodeField.text];
    [packet setProdtaNo:self.prodTaNo];
    //还差一个 sub_risk_flag 入参，目前不知道从哪里获取
    [[HsTradeConfigration sharedManager].usermodels setLoginInfoToPacket:packet];
    
    HsNetEvent *event = [[HsNetEvent alloc] initWithPacketObject:packet];
    [event setSenderId:SENDID_SIGN_ECONTRACT];
    [HsNetworkController sendRequest:event Delegate:self];
    
    [packet release];
    [event release];
}

- (void)responseForSignEContract:(HsNetEvent*)event
{
    [self showEntrustComfirm];
}
- (void)sendRequest
{
    [self sendProductCodeInfoRequest];
}
//207
-(void) sendAddAuthorityRequest:(id)delegate
{
    HsCustomerAddAuthority *addAuthorityPacket = [[HsCustomerAddAuthority alloc]init];
    [[HsTradeConfigration sharedManager].usermodels setLoginInfoToPacket:addAuthorityPacket];
    NSString *agreementRightTag = [HsConfigration readConfigWithKey:kHsESignatureAgreementRightTagKey];
    [addAuthorityPacket setClientRights:agreementRightTag];
    HsNetEvent *event = [[HsNetEvent alloc]initWithPacketObject:addAuthorityPacket];
    [event setSenderId: SIGNATURE_AGREEMENT_FUNCTIONID];
    [HsNetworkController sendRequest: event Delegate: delegate];
    
    [addAuthorityPacket release];
    [event release];
}
-(void) responseAddAuthorityRequest:(id)delegate
{
//    [HsConfigration writeConfigWithKey:kHsETCAgreementRightsKey WithValue:@"1"];//1: 已签署 0：未签署
    [HsTradeConfigration sharedManager].usermodels.authorityStatus = @"1";
}

- (BOOL)onNetResponse:(HsNetEvent *)event{
    int senderId = [event getSenderId];
    if([event getReturnCode] || [event getErrorNO])
    {
        [HsConfigration MessageBox:[event getErrorInfo]];
        return NO;
    }
    
    switch (senderId) {
        case SERVICE_PRODUCT_QUERY_SENDERID:
            [self responseForCodeInfoRequest:event];
            break;
        
        case TRADE_ENABLE_MONEY:
            [self responseForBankCapital:event];
            break;
        case SERVICE_PRODUCT_ENTRUST_SENDERID:
            [self responseForServicePREntrust:event];
            //刷新可用金额
            [HsTradeQueryUtils sendBankCapitalQuery:self senderID:TRADE_ENABLE_MONEY];
            break;
       
        case SIGNATURE_AGREEMENT_FUNCTIONID:
            [self responseAddAuthorityRequest:event];
            [self judgeFlowNumber];
            break;
        case ECONTRACT_QUERY_SENDERID:
            [self responseForEContractQuery:event];
            break;
        case SENDID_SIGN_ECONTRACT:
            [self responseForSignEContract:event];
            break;

            
        default:
            break;
    }
    
    return YES;
}


#pragma mark - IBAction part

- (void)resetPressed
{
    _productCodeField.text = @"";
    _productNameValue.text = @"";
    _productTermValue.text = @"";
    _issuePriceValue.text = @"";
    //_enableMoneyValue.text = @"";
    _entrustAmountField.text = @"";
    _hintLabel.text = @"";
}
- (void)resetPressedExceptCodeField
{
    _productNameValue.text = @"";
    _productTermValue.text = @"";
    _issuePriceValue.text = @"";
    //_enableMoneyValue.text = @"";
    _entrustAmountField.text = @"";
    _hintLabel.text = @"";
}

//风险评测页面提交成功
-(void)testCommitSuccess
{
    //0:直接委托
    if ([self.eContractFlag isEqualToString:SIGNED_CONTRACT]) {
        [self showEntrustComfirm];
    }
    //1或2
    else{
        
        //1: 已签署 0：未签署
        if ([[HsTradeConfigration sharedManager].usermodels.authorityStatus isEqualToString:@"0"]) {
            [self showSignatureAgreement];
        }
        else{
            [self judgeFlowNumber];
        }
        
    }
    
}
- (void)confirmPressed
{
    [self _removeTextFieldFocus];
    if ([self inputFieldValidate]) {
        
        //先判断风险等级
        if(![HsTradeConfigration sharedManager].usermodels.corpValidNormal){
            
            //弹出风险页面
            HsMessage *message = [[HsMessage alloc]init];
            message.number     = kHsEventTradeAddMainPage;
            HsTradeSuitableTestPage *page = (HsTradeSuitableTestPage *)[HsComponentFactory createAndRegComponent:@"tradeSuitableTestPage" withParam:nil];
            [message.params setObject:page forKey:kHsEventParamFramePage];
            page.delegate = self;
            [HsTradeConfigration distributeTradeMessage:message];
            [message release];
        }
        //进入电子合同流程
        else{
            //0:直接委托提示
            if ([self.eContractFlag isEqualToString:SIGNED_CONTRACT]) {
                [self showEntrustComfirm];
            }
            //1或2
            else{
                
                //1: 已签署 0：未签署
                if ([[HsTradeConfigration sharedManager].usermodels.authorityStatus isEqualToString:@"0"]) {
                    [self showSignatureAgreement];
                }
                else{
                    [self judgeFlowNumber];
                }
                
            }
        }
    }
}
- (void)_removeTextFieldFocus
{
    if ([_productCodeField isFirstResponder]) {
        [_productCodeField resignFirstResponder];
    }
    if ([_entrustAmountField isFirstResponder]) {
        [_entrustAmountField resignFirstResponder];
    }
}
-(void)judgeFlowNumber
{
    //判断流水条数,空的话弹电子合同签署界面
    if(!_isHasEContract){
        [self showEContract];
    }
    //有流水记录
    else{
        //有记录，判断是否为2
        if ([self.eContractFlag isEqualToString:ALWAYS_SIGN_CONTRACT]) {
            [self showEContract];
            
        }
        //有记录，flag为1
        else{
            [self showEntrustComfirm];
        }
        
    }
    
}

#pragma mark - alert view part
-(void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{
    
    if (0 == buttonIndex) {
        if (alertView.tag== ALERT_ENTRUST_COMFIRM) {
            [self sendServicePREntrust];
        }
       
    }
}
-(void)signContractView:(HsSignContractView*)signView DissmissWithButtonIndex:(NSInteger)n
{
    if (0 == n) {
        if(signView.tag == SIGNATURE_AGREEMENT_TAG){
            
            [self sendAddAuthorityRequest:self];
            
        }
        
    }
}



#pragma mark - textfield delegate method

//buy price must be integral multiples
- (BOOL)validateMoney:(NSString*)money
{
    NSInteger m = [money integerValue];
    NSInteger n = [_issuePriceValue.text integerValue];
    if (m % n != 0 ||  m/n < [[_productTermDic objectForKey:_productCodeField.text  ] integerValue]) {
        return NO;
    }
    return YES;
}

- (BOOL)inputFieldValidate
{
    if ([_productCodeField.text length] == 0) {
        [HsConfigration MessageBox:@"产品代码不能为空！"];
        return NO;
    }
    else if ([_entrustAmountField.text length] == 0) {
        NSString *message = nil;
        message = @"购买金额不能为空！";
 
        [HsConfigration MessageBox:message];
        return NO;
    }
    else if([self validateMoney: _entrustAmountField.text] == NO	)
    {
        NSString *s = [_productTermDic objectForKey:_productCodeField.text];
        [HsConfigration MessageBox:[NSString stringWithFormat:@"本产品至少需购买%@个月，请输入%@或%@以上整数倍产品价格的金额",s,s,s]];
        return NO;
    }
    return YES;
}


-(void)_textFieldEditingChanged:(UITextField *)textField//变化之后
{
    if ([textField.text length] == OTC_STOCK_CODE_LENGTH_MAX) {
        [self sendProductCodeInfoRequest];
        [self textFieldShouldReturn:textField];
    }
    else if([textField.text length] > OTC_STOCK_CODE_LENGTH_MAX){
        textField.text=[textField.text substringToIndex:OTC_STOCK_CODE_LENGTH_MAX];
    }
    if ([textField.text length] < OTC_STOCK_CODE_LENGTH_MAX ) {
        [self resetPressedExceptCodeField];
    }
}

- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
    return YES;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    
    return YES;
}

- (void)willMoveToWindow:(UIWindow *)newWindow
{
    if (newWindow) {
        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(keyboardWillShow:) name: UIKeyboardWillShowNotification object: nil];
        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(keyboardWillHide:) name: UIKeyboardWillHideNotification object: nil];
    }
    else
    {
        [[NSNotificationCenter defaultCenter] removeObserver: self];
    }
}
- (void)keyboardWillShow: (NSNotification*)notice
{
    if ([_entrustAmountField isFirstResponder]) {
        [_scrollView setContentOffset: CGPointMake(0, 50) animated: YES];
    }
}
- (void)keyboardWillHide:(NSNotification*)notice
{
    [_scrollView setContentOffset: CGPointMake(0, 0) animated: YES];
}

   

#pragma mark - private method

- (UILabel *)_generateHintLabel
{
    UILabel *tempLabel = [[UILabel alloc] init];
    tempLabel.font = [HsConfigration systemFontOfSize: 16.0f];
    tempLabel.backgroundColor = [UIColor clearColor];
    tempLabel.textColor = [HsConfigration uiColorFromString:@"#373737"];
    [_scrollView addSubview:tempLabel];
    
    return [tempLabel autorelease];
}

- (UITextField *)_generateTextField
{
    HsTextField *tempTextField = [[HsTextField alloc]init];
    tempTextField.contentVerticalAlignment  = UIControlContentVerticalAlignmentCenter;
    tempTextField.borderStyle = UITextBorderStyleRoundedRect;
    tempTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
    tempTextField.keyboardType = UIKeyboardTypeNumberPad;
    tempTextField.clearsOnBeginEditing = NO;
    tempTextField.font = [HsConfigration systemFontOfSize:16.0f];
    tempTextField.delegate = self;
    [_scrollView addSubview: tempTextField];
    
    return [tempTextField autorelease];
}
- (void)showEntrustComfirm
{
    //委托确认提示
    NSString* messageInfo = [NSString stringWithFormat:@"产品代码:%@\r产品名称:%@\r发行价格:%@\r可用资金:%@\r%@:%@\r",_productCodeField.text,_productNameValue.text, _issuePriceValue.text,_enableMoneyValue.text, _entrustAmountHint.text, _entrustAmountField.text];
    
    UIAlertView *rsMessage = [[[UIAlertView alloc] initWithTitle:@"交易确认" message: messageInfo delegate:self cancelButtonTitle:@"确定" otherButtonTitles:@"取消",nil] autorelease];
    rsMessage.tag=ALERT_ENTRUST_COMFIRM;
    [rsMessage show];
    
}
- (void)showEContract
{
    HsFundSignContractView * signContract = [[HsFundSignContractView alloc] initWithFrame:CGRectMake(20, 40, 280, 380)];
    signContract.delegate = self;
    signContract.eContractType = kHsOTCBankEContractType;
    signContract.contentURL = self.eContractContent;
    signContract.fundCode = _productCodeField.text;
    [signContract showInFront];
    [signContract release];
}
- (void)SignContract:(HsFundSignContractViewBase*)signContract OnConfirmed:(NSInteger)nOKCancel
{
    if (!_isHasEContract) {
        //需要签署合同
        [self sendSignEContract];
    }
    else{
        [self showEntrustComfirm];
    }
    
}
- (void)showSignatureAgreement
{
    HsSignContractView * signContract = [[HsSignContractView alloc] initWithFrame:CGRectZero];
    signContract.title = @"电子签名约定书";
    signContract.content =[HsConfigration readConfigWithKey:kHsESignatureAgreementContentKey];
    signContract.prompt = @"我已详细阅读,并完全接受上述条款";
    signContract.tag = SIGNATURE_AGREEMENT_TAG;
    [signContract showContract];
    signContract.delegate = self;
    [signContract release];
}


#pragma mark - public creators

+(id)createOTCServiceProductBuyPage:(id)params
{
    HsOTCServicePRPage *page = [[HsOTCServicePRPage alloc] init];
    page.frame = CGRectMake(0, 0, MAIN_SCREEN_WIDTH, MAIN_SCREEN_HEIGHT);
    
    page.title = @"产品购买";
    page.targetName = @"OTCServiceProductBuyPage";
//    page.pageType = HsPageOTCBankProductRedeem;
      [page setData:[params objectForKey:@"funddata"]];
    return [page autorelease];
}

@end
